#!/bin/bash
#path to ppp
ppp=/etc/ppp

if [[ $(id) != 'uid=0'* ]]; then
echo "Только пользователь с правами root может настраивать VPN. Также вы можете воспользоваться командой 'sudo'"
exit 1
fi
echo "Вас приветствует скрипт для настройки VPN-соединений! Вам будет задано несколько вопросов, и если Вы корректно и точно на них ответите - то получите рабочее VPN-соединение с настроенными маршрутами! Помните - причина 99% ошибок и неудач при настройке VPN с помощью этого скрипта - это банальная невнимательность! Будьте внимательны и успехов Вам!"
echo "Итак, приступим!"
echo "------------------------"
printf "Введите название VPN-соединения (например, corbina или vpn_corbina): "
read i_vpn_name
echo "------------------------"
echo "Выберите пожалуйста, своего провайдера:"
echo "   1. Корбина-Телеком"
echo "   2. Билайн"
echo "   3. Другой"
printf "Ваш провайдер? (1/2/3)? " 
read provider
if [ $provider = "1" ]; then
prov="Корбина-Телеком"
vpn_address="vpn.corbina.net"
elif [ $provider = "2" ]; then
prov="Билайн"
vpn_address="vpn.internet.beeline.ru"
elif [ $provider = "3" ]; then
prov="Другой"
echo "ВНИМАНИЕ! Вы должны отредактировать файл 'route' (он скачивается, как правило, в домашнюю папку, либо лежит в папке vpn_prj, если вы распаковывали архив со скачанным скриптом) т.к. он настроен для работы в Корбине и Билайн. Маршруты для вашего провайдера уточняйте в службе поддержки. Остановите скрипт командой Ctrl+C для завершения скрипта, отредактируйте файл 'route' и запустите скрипт заново из вашей домашней директории."
echo "------------------------"
printf "Введите свой адрес VPN: "
read vpn_address
else
echo "Вы ввели неправильный вариант ответа. Пожалуйста, запустите скрипт заново."
exit 1
fi

if [ $provider = "3" ]; then
region="3"
routes="route"
else
echo "------------------------"
echo "Выберите пожалуйста, ваш регион:"
echo "   1. Москва и МО"
echo "   2. Санкт-Петербург и ЛО"
echo "   3. Другой"
printf "Ваш регион? (1/2/3)? "
read region
if [ $region = "1" ]; then
region_name="Москва и МО"
routes="route.msk"
elif [ $region = "2" ]; then
region_name="Санкт-Петербург и ЛО"
routes="route.piter"
elif [ $region = "3" ]; then
region_name="Другой"
routes="route"
else
echo "Вы ввели неправильный вариант ответа. Пожалуйста, запустите скрипт заново."
exit 1
fi
fi

echo "------------------------"
printf "Введите ваш логин для доступа в интернет: "
read i_login
echo "------------------------"
printf "Введите ваш пароль для доступа в интернет: "
read i_password

echo "------------------------"
echo "Автоматически определяется адрес вашего шлюза..." 
i_gw=$(route|grep default|awk '{print $2}')
echo "Определено!"
echo "IP вашего районного шлюза: $i_gw"
if [ $provider = "3" ]; then
printf "Районный шлюз определён правильно: (y/n) ? "
read i_yn
if [ $i_yn = "n" ]; then
printf "Введите IP-адрес вашего шлюза: "
read i_gw
fi
else
if [[ $i_gw != '10.'* ]]; then
echo "К сожалению, IP-адрес шлюза определился неправильно. Он должен иметь вид 10.x.x.x, поэтому Вам нужно ввести его вручную."
printf "Введите IP-адрес вашего шлюза: "
read i_gw
fi
fi
if [ $region = "2" ]; then
routing="Преднастроенные маршруты в файле 'route', т.к. в Санкт-Петербург и ЛО нет поддержки DHCP-маршрутов"
i_dhcp="n"
else
echo "------------------------"
echo "Теперь вы должны выбрать метод получения маршрутов. Вы можете выбрать автополучение маршрутов по DHCP или предустановленный набор в файле 'route'"
echo "------------------------"
printf "Вы хотите получать маршруты через DHCP? ([y]/n)? " 
read i_dhcp
if [ $i_dhcp = "y" ]; then
routing="Получение через DHCP"
elif [ $i_dhcp = "n" ]; then
routing="Преднастроенные маршруты в файле 'route'"
if [ $provider = "3" ]; then
echo "ВНИМАНИЕ! Вы должны отредактировать файл 'route' (он скачивается, как правило, в домашнюю папку, либо лежит в папке vpn_prj, если вы распаковывали архив со скачанным скриптом) т.к. он настроен для работы в Корбине и Билайн. Маршруты для вашего провайдера уточняйте в службе поддержки. Остановите скрипт командой Ctrl+C для завершения скрипта, отредактируйте файл 'route' и запустите скрипт заново из вашей домашней директории."
fi
else
echo "Вы ввели неправильный вариант ответа. Пожалуйста, запустите скрипт заново."
exit 1
fi
fi
echo "------------------------"
printf "Хотите автоматически установить пакет pptp-linux? Отвечайте 'n' если он уже установлен в системе, или у вас устаревший дистрибутив (Debian Etch, Xandros, установленный на Eee PC и т.п.) (y/n): " 
read i_install
if [ $i_install = "y" ]; then
pptp_linux="Да"
else
pptp_linux="Нет"
fi
echo "------------------------"
echo "Проверка введённых данных:"
echo "		Имя соединения: $i_vpn_name"
echo "		Провайдер: $prov"
if [[ $provider != "3" ]]; then
echo "		Регион: $region_name"
fi
echo "		Логин: $i_login"
echo "		Пароль: $i_password"
echo "		Адрес VPN-сервера: $vpn_address"
echo "		Шлюз: $i_gw"
echo "		Настройка маршрутов: $routing"
echo "		Установка пакета pptp-linux: $pptp_linux"
printf "Вся информация верна? (y/n)? "
read i_correct
if [ $i_correct = "n" ]; then
echo "------------------------"
echo "Уточните данные и запустите скрипт заново."
exit 1
fi

if [ $i_install = "y" ]; then
echo "Определяется тип вашей системы..."
bit=$(uname -m)
echo "Тип вашей системы определён как: $bit"
echo "Устанавливается $bit версия pptp-linux..."
if [ $bit = "i686" ]; then
dpkg -i "$PWD"/pptp-linux_1.7.0-2ubuntu2_i386.deb
elif [ $bit = "x86_64" ]; then
dpkg -i "$PWD"/pptp-linux_1.7.0-2ubuntu2_amd64.deb
fi
fi

if [ $i_dhcp = "y" ]; then
cp "$PWD"/rfc3442-classless-static-routes /etc/dhcp3/dhclient-exit-hooks.d/rfc3442-classless-static-routes
mv /etc/dhcp3/dhclient.conf /etc/dhcp3/dhclient.conf_bak
cp "$PWD"/dhclient.conf /etc/dhcp3/dhclient.conf
echo "------------------------"
echo "Автонастройка маршрутов через DHCP установлена."
fi
echo "------------------------"
echo "Создаются VPN-параметры..."


echo "${i_login} PPTP ${i_password} *" > $ppp/chap-secrets


cp "$PWD"/ip $ppp/ip-up > /dev/null
printf "${ppp}/ip-up.d/\$6 \$1 \$2 \$3 \$4 \$5 \$6" >> $ppp/ip-up
chmod a+x $ppp/ip-up

cp "$PWD"/ip $ppp/ip-down > /dev/null
printf "${ppp}/ip-down.d/\$6 \$1 \$2 \$3 \$4 \$5 \$6" >> $ppp/ip-down
chmod a+x $ppp/ip-down

cp "$PWD"/$routes $ppp/ip-up.d/$i_vpn_name

printf "route del \$4 dev \$1\n" >> $ppp/ip-up.d/$i_vpn_name
printf "route add -host \$4 gw ${i_gw}\n" >> $ppp/ip-up.d/$i_vpn_name
printf "do_route add ${i_gw} \n" 	>> $ppp/ip-up.d/$i_vpn_name
printf "route del default \n" 	  	>> $ppp/ip-up.d/$i_vpn_name
printf "route add default dev \$1 \n" 	>> $ppp/ip-up.d/$i_vpn_name

chmod a+x $ppp/ip-up.d/$i_vpn_name

cp "$PWD"/$routes $ppp/ip-down.d/$i_vpn_name
printf "do_route del ${i_gw} \n"	>> $ppp/ip-down.d/$i_vpn_name
printf "route del default \n" 		>> $ppp/ip-down.d/$i_vpn_name
printf "route add default gw ${i_gw}\n" >> $ppp/ip-down.d/$i_vpn_name
chmod a+x $ppp/ip-down.d/$i_vpn_name

printf "nodeflate\nnobsdcomp\nnoauth\n" > $ppp/options.$i_vpn_name

printf "pty \"pptp $vpn_address --nolaunchpppd --nobuffer --loglevel 0\"\n" > $ppp/peers/$i_vpn_name
printf "connect /bin/true\n" >> $ppp/peers/$i_vpn_name
printf "name ${i_login}\n" >> $ppp/peers/$i_vpn_name
printf "remotename PPTP\n" >> $ppp/peers/$i_vpn_name
printf "file ${ppp}/options.$i_vpn_name\n" >> $ppp/peers/$i_vpn_name
printf "ipparam $i_vpn_name\n" >> $ppp/peers/$i_vpn_name
printf "persist\n" >> $ppp/peers/$i_vpn_name
printf "maxfail 0\n" >> $ppp/peers/$i_vpn_name
printf "lcp-echo-interval 30\n" >> $ppp/peers/$i_vpn_name
printf "lcp-echo-failure 4\n" >> $ppp/peers/$i_vpn_name
printf "mtu 1460\n" >> $ppp/peers/$i_vpn_name
echo "------------------------"
echo "Оптимизация настроек соединения выполнена!"
echo "------------------------"
echo "Автоматическое восстановление соединения после разрыва настроено!"
echo "------------------------"
echo "Настройка параметров успешно завершена!"
echo "------------------------"
echo "Перезагрузка сетевых служб..."
/etc/init.d/networking restart
echo "Выполнено!"
echo "------------------------"
printf "Вы хотите создать VPN-соединение с интернетом сейчас? ([y]/n)? " 
read i_vpnstart
if [ $i_vpnstart = "y" ]; then
echo "------------------------"
echo "Запускается VPN-соединение..."
pon $i_vpn_name
echo "VPN-соединение запущено. Если всё сделано правильно и на счёте есть деньги то Вы в интернете:)"
echo "------------------------"
echo "Чтобы подключиться к интернету, напечатайте в консоли: sudo pon $i_vpn_name" 
echo "Чтобы разорвать соединение, напечатайте в консоли: sudo poff"
echo "------------------------"
echo "Не забудьте сказать спасибо на форуме) По всем вопросам об этом скрипте - http://homenet.corbina.net/index.php?showtopic=199266"
else
echo "------------------------"
echo "Чтобы подключиться к интернету, напечатайте в консоли: sudo pon $i_vpn_name" 
echo "Чтобы разорвать соединение, напечатайте в консоли: sudo poff"
echo "------------------------"
echo "Не забудьте сказать спасибо на форуме) По всем вопросам об этом скрипте - http://homenet.corbina.net/index.php?showtopic=199266"
fi
exit 0
